<?php

namespace FiloBlu\OrderAdditionalData\Api;

use Magento\Framework\Api\CustomAttributesDataInterface;

/**
 * Interface AdditionalDataInterface
 * @package FiloBlu\OrderAdditionalData\Api
 */
interface AdditionalDataInterface extends CustomAttributesDataInterface {

    /**
     * Get an attribute value.
     *
     * @param string $attributeCode
     * @return \Magento\Framework\Api\AttributeInterface|null
     */
    public function getCustomAttribute($attributeCode);

    /**
     * Set an attribute value for a given attribute code
     *
     * @param string $attributeCode
     * @param mixed $attributeValue
     * @return \FiloBlu\OrderAdditionalData\Api\AdditionalDataInterface
     */
    public function setCustomAttribute($attributeCode, $attributeValue);

    /**
     * Retrieve custom attributes values.
     *
     * @return \Magento\Framework\Api\AttributeInterface[]|null
     */
    public function getCustomAttributes();

    /**
     * Set array of custom attributes
     *
     * @param \Magento\Framework\Api\AttributeInterface[] $attributes
     * @return \FiloBlu\OrderAdditionalData\Api\AdditionalDataInterface
     * @throws \LogicException
     */
    public function setCustomAttributes(array $attributes);
}
